// Header file
#pragma chip PIC17C42A, core 16 b, code 2048, ram 26 : 0xFF

/* Predefined:
INDF0, FSR0,
PCL, PCLATH,
ALUSTA, T0STA, CPUSTA, INTSTA,
INDF1, FSR1,
WREG,
TMR0L, TMR0H,
TBLPTR, TBLPTRL, TBLPTRH,
BSR, BSRL, BSRH,
PRODL, PRODH,
Carry,DC,Zero_,Overflow
*/


char PORTA    @ 0x10;
char DDRB     @ 0x11;
char PORTB    @ 0x12;
char RCSTA    @ 0x13;
char RCREG    @ 0x14;
char TXSTA    @ 0x15;
char TXREG    @ 0x16;
char SPBRG    @ 0x17;

char DDRC     @ 0x110;
char PORTC    @ 0x111;
char DDRD     @ 0x112;
char PORTD    @ 0x113;
char DDRE     @ 0x114;
char PORTE    @ 0x115;
char PIR      @ 0x116;
char PIE      @ 0x117;

char TMR1     @ 0x210;
char TMR2     @ 0x211;
char TMR3L    @ 0x212;
char TMR3H    @ 0x213;
char PR1      @ 0x214;
char PR2      @ 0x215;
char PR3L     @ 0x216;
char CA1L     @ 0x216;
char PR3H     @ 0x217;
char CA1H     @ 0x217;

char PW1DCL   @ 0x310;
char PW2DCL   @ 0x311;
char PW1DCH   @ 0x312;
char PW2DCH   @ 0x313;
char CA2L     @ 0x314;
char CA2H     @ 0x315;
char TCON1    @ 0x316;
char TCON2    @ 0x317;


bit PS0    @ T0STA.1;
bit PS1    @ T0STA.2;
bit PS2    @ T0STA.3;
bit PS3    @ T0STA.4;
bit T0CS   @ T0STA.5;
bit T0SE   @ T0STA.6;
bit INTEDG @ T0STA.7;

bit PD     @ CPUSTA.2;
bit TO     @ CPUSTA.3;
bit GLINTD @ CPUSTA.4;
bit STKAV  @ CPUSTA.5;

bit INTE   @ INTSTA.0;
bit T0IE   @ INTSTA.1;
bit T0CKIE @ INTSTA.2;
bit PEIE   @ INTSTA.3;
bit INTF   @ INTSTA.4;
bit T0IF   @ INTSTA.5;
bit T0CKIF @ INTSTA.6;
bit PEIF   @ INTSTA.7;

bit INT    @ PORTA.0;
bit T0CKI  @ PORTA.1;
bit RBPU_  @ PORTA.7;

bit RX9D   @ RCSTA.0;
bit OERR   @ RCSTA.1;
bit FERR   @ RCSTA.2;
bit CREN   @ RCSTA.4;
bit SREN   @ RCSTA.5;
bit RX9    @ RCSTA.6;
bit SPEN   @ RCSTA.7;

bit TX9D   @ TXSTA.0;
bit TRMT   @ TXSTA.1;
bit SYNC   @ TXSTA.4;
bit TXEN   @ TXSTA.5;
bit TX9    @ TXSTA.6;
bit CSRC   @ TXSTA.7;

bit AD0    @ PORTC.0;
bit AD1    @ PORTC.1;
bit AD2    @ PORTC.2;
bit AD3    @ PORTC.3;
bit AD4    @ PORTC.4;
bit AD5    @ PORTC.5;
bit AD6    @ PORTC.6;
bit AD7    @ PORTC.7;

bit AD8    @ PORTD.0;
bit AD9    @ PORTD.1;
bit AD10   @ PORTD.2;
bit AD11   @ PORTD.3;
bit AD12   @ PORTD.4;
bit AD13   @ PORTD.5;
bit AD14   @ PORTD.6;
bit AD15   @ PORTD.7;

bit ALE    @ PORTE.0;
bit OE_    @ PORTE.1;
bit WR_    @ PORTE.2;

bit RCIF   @ PIR.0;
bit TXIF   @ PIR.1;
bit CA1IF  @ PIR.2;
bit CA2IF  @ PIR.3;
bit TMR1IF @ PIR.4;
bit TMR2IF @ PIR.5;
bit TMR3IF @ PIR.6;
bit RBIF   @ PIR.7;

bit RCIE   @ PIE.0;
bit TXIE   @ PIE.1;
bit CA1IE  @ PIE.2;
bit CA2IE  @ PIE.3;
bit TMR1IE @ PIE.4;
bit TMR2IE @ PIE.5;
bit TMR3IE @ PIE.6;
bit RBIE   @ PIE.7;

bit TM2PW2 @ PW2DCL.5;

bit TMR1CS @ TCON1.0;
bit TMR2CS @ TCON1.1;
bit TMR3CS @ TCON1.2;
bit T16    @ TCON1.3;
bit CA1ED0 @ TCON1.4;
bit CA1ED1 @ TCON1.5;
bit CA2ED0 @ TCON1.6;
bit CA2ED1 @ TCON1.7;

bit TMR1ON @ TCON2.0;
bit TMR2ON @ TCON2.1;
bit TMR3ON @ TCON2.2;
bit CA1_PR3@ TCON2.3;
bit PWM1ON @ TCON2.4;
bit PWM2ON @ TCON2.5;
bit CA1OVF @ TCON2.6;
bit CA2OVF @ TCON2.7;
